Merge branch 'master' of git+ssh://db.debian.org/git/dsa-nagios
[mirror/dsa-nagios.git] / dsa-nagios-checks / checks / dsa-check-running-kernel
1 #!/bin/bash
2
3 # Check if the running kernel has the same version string as the on-disk
4 # kernel image.
5
6 # Copyright 2008,2009 Peter Palfrader
7 # Copyright 2009 Stephen Gran
8 # Copyright 2010 Uli Martens
9 # Copyright 2011 Alexander Reichle-Schmehl
10 #
11 # Permission is hereby granted, free of charge, to any person obtaining
12 # a copy of this software and associated documentation files (the
13 # "Software"), to deal in the Software without restriction, including
14 # without limitation the rights to use, copy, modify, merge, publish,
15 # distribute, sublicense, and/or sell copies of the Software, and to
16 # permit persons to whom the Software is furnished to do so, subject to
17 # the following conditions:
18 #
19 # The above copyright notice and this permission notice shall be
20 # included in all copies or substantial portions of the Software.
21 #
22 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
23 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
24 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
25 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
26 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
27 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
28 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
29
30 OK=0;
31 WARNING=1;
32 CRITICAL=2;
33 UNKNOWN=3;
34
35 get_offset() {
36         local file needle
37
38         file="$1"
39         needle="$2"
40         perl -e '
41                 undef $/;
42                 $i = index(<>, "'"$needle"'");
43                 if ($i < 0) {
44                         exit 1;
45                 };
46                 print $i,"\n"' < "$file"
47 }
48
49 get_avail_linux() {
50         # This is wrong, but leaves room for when we have to care for machines running
51         # myfirstunix-image-0.1-dsa-arm
52         local prefix=linux
53
54         local kervers=$(uname -r)
55
56         local metavers=''
57
58         # DSA uses kernel versions of the form 2.6.29.3-dsa-dl380-oldxeon, where
59         # Debian uses versions of the form 2.6.29-2-amd64
60         if [ "${kervers//dsa}" != "$kervers" ]; then
61                 metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+([\.0-9]+?)-(.*)/2.\1-\3/')
62         else
63                 metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+-[A-Za-z0-9\.]+-(.*)/2.\1-\2/')
64         fi
65
66         # Attempt to track back to a metapackage failed.  bail
67         if [ "$metavers" = "$kervers" ]; then
68                 return 2
69         fi
70
71         # We're just going to give up if we can't find a matching metapackage
72         # I tried being strict once, and it just caused a lot of headaches.  We'll see how
73         # being lax does for us
74
75         local output=$(apt-cache policy ${prefix}-image-${metavers} 2>/dev/null)
76         local metaavailvers=$(echo "$output" | grep '^  Candidate:' | awk '{print $2}')
77         local metainstavers=$(echo "$output" | grep '^  Installed:' | awk '{print $2}')
78
79         if [ -z "$metaavailvers" ] || [ "$metaavailvers" = '(none)' ]; then
80                 return 2
81         fi
82         if [ -z "$metainstavers" ] || [ "$metainstavers" = '(none)' ]; then
83                 return 2
84         fi
85
86         if [ "$metaavailvers" != "$metainstavers" ] ; then
87                 echo "${prefix}-image-${metavers} $metaavailvers available but $metainstavers installed"
88                 return 1
89         fi
90
91         local imagename=0
92         # --no-all-versions show shows only the candidate
93         for vers in $(apt-cache --no-all-versions show ${prefix}-image-${metavers} | sed -n 's/^Depends: //p' | tr ',' '\n' | tr -d ' ' | grep ${prefix}-image | awk '{print $1}' | sort -u); do
94                 if dpkg --compare-versions $vers gt $imagename; then
95                         imagename=$vers
96                 fi
97         done
98
99         if [ -z "$imagename" ] || [ "$imagename" = 0 ]; then
100                 return 2
101         fi
102
103         if [ "$imagename" != "${prefix}-image-${kervers}" ]; then
104                 if dpkg --compare-versions "$imagename" lt "${prefix}-image-${kervers}"; then
105                         return 2
106                 fi
107                 echo "$imagename" != "${prefix}-image-${kervers}"
108                 return 1
109         fi
110
111         local availvrs=$(apt-cache policy ${imagename} 2>/dev/null | grep '^  Candidate' | awk '{print $2}')
112         local kernelversion=$(apt-cache policy ${prefix}-image-${kervers} 2>/dev/null | grep '^  Installed:' | awk '{print $2}')
113
114         if [ "$availvrs" = "$kernelversion" ]; then
115                 return 0
116         fi
117
118         echo "$kernelversion != $availvrs"
119         return 1
120 }
121
122 get_image_linux() {
123         local image GZHDR1 GZHDR2 LZHDR off
124
125         image="$1"
126
127         GZHDR1="\x1f\x8b\x08\x00"
128         GZHDR2="\x1f\x8b\x08\x08"
129         LZHDR="\x00\x00\x00\x02\xff"
130
131         off=`get_offset "$image" $GZHDR1`
132         [ "$?" != "0" ] && off="-1"
133         if [ "$off" -eq "-1" ]; then
134                 off=`get_offset "$image" $GZHDR2`
135                 [ "$?" != "0" ] && off="-1"
136         fi
137         if [ "$off" -eq "0" ]; then
138                 zcat < "$image"
139                 return
140         elif [ "$off" -ne "-1" ]; then
141                 (dd ibs="$off" skip=1 count=0 && dd bs=512k) < "$image"  2>/dev/null | zcat 2>/dev/null
142                 return
143         fi
144
145         off=`get_offset "$image" $LZHDR`
146         [ "$?" != "0" ] && off="-1"
147         if [ "$off" -ne "-1" ]; then
148                 (dd ibs="$[off-1]" skip=1 count=0 && dd bs=512k) < "$image" 2>/dev/null | lzcat 2>/dev/null
149                 return
150         fi
151
152         echo "ERROR: Unable to extract kernel image." 2>&1
153         exit 1
154 }
155
156 searched=""
157 for on_disk in \
158         "/boot/vmlinuz-`uname -r`"\
159         "/boot/vmlinux-`uname -r`"\
160         "/boot/kfreebsd-`uname -r`.gz"; do
161
162         if [ -e "$on_disk" ]; then
163                 if [ ! -x "$(which strings)" ]; then
164                         echo "UNKNOWN: 'strings' command missing, perhaps install binutils?"
165                         exit $UNKNOWN
166                 fi
167                 if [ "${on_disk/vmlinu}" != "$on_disk" ]; then
168                         on_disk_version="`get_image_linux "$on_disk" | strings | grep 'Linux version' | head -n1`"
169                         if [ -x /usr/bin/lsb_release ] ; then
170                                 vendor=$(lsb_release -i -s)
171                                 if [ -n "$vendor" ] && [ "xDebian" != "x$vendor" ] ; then
172                                         on_disk_version=$( echo $on_disk_version|sed -e "s/ ($vendor [[:alnum:]\.-]\+ [[:alnum:]\.]\+)//")
173                                 fi
174                         fi
175                         [ -z "$on_disk_version" ] || break
176                         on_disk_version="`cat "$on_disk" | strings | grep 'Linux version' | head -n1`"
177                         [ -z "$on_disk_version" ] || break
178
179                         echo "UNKNOWN: Failed to get a version string from image $on_disk"
180                         exit $UNKNOWN
181                 else
182                         on_disk_version="$(zcat $on_disk | strings | grep Debian | head -n 1 | sed -e 's/Debian [[:alnum:]]\+ (\(.*\))/\1/')"
183                 fi
184         fi
185         searched="$searched $on_disk"
186 done
187
188 if ! [ -e "$on_disk" ]; then
189         echo "WARNING: Did not find a kernel image (checked$searched) - I have no idea which kernel I am running"
190         exit $WARNING
191 fi
192
193 if [ "$(uname -s)" = "Linux" ]; then
194         running_version="`cat /proc/version`"
195         if [ -z "$running_version" ] ; then
196                 echo "UNKNOWN: Failed to get a version string from running system"
197                 exit $UNKNOWN
198         fi
199
200         if [ "$running_version" != "$on_disk_version" ]; then
201                 echo "WARNING: Running kernel does not match on-disk kernel image: [$running_version != $on_disk_version]"
202                 exit $WARNING
203         fi
204
205         ret="$(get_avail_linux)"
206         if [ $? = 1 ]; then
207                 echo "WARNING: Kernel needs upgrade [$ret]"
208                 exit $WARNING
209         fi
210 else
211         echo "No support for FreeBSD yet"
212         exit $OK
213 fi
214
215 echo "OK: Running kernel matches on disk image: [$running_version]"
216 exit $OK